#include "book-index.h"
#include <iostream>

using namespace litindex;

BookIndex::BookIndex(int c, int s, int p)
{
   this->set_chapter(c);
   this->set_section(s);
   this->set_page(p);
}

BookIndex::BookIndex(int c, int s, int p, int year, std::string pid)
{
   this->set_chapter(c);
   this->set_section(s);
   this->set_page(p);
   this->set_year(year);
   this->set_persistent_identifier(pid);
}

/*
 * goes to next chapter, returns new chapter number
 * this implementation also automatically goes to the next page
 */
int BookIndex::next_chapter()
{
   chapter++;
   section = 1;
   page++;
   return chapter;
}

/*
 * goes to next section, returns new section number
 */
int BookIndex::next_section()
{
   section++;
   return section;
}

/*
 * goes to next page, returns new page number
 */
int BookIndex::next_page()
{
   page++;
   return page;
}

/*
 * write to stdout
 */
void BookIndex::out() const
{
   std::cout << "Section " << this->chapter << "." << this->section << ", p. " << this->page;
   if(this->get_persistent_identifier() != "") std::cout << " in " << this->get_persistent_identifier();
   if(this->get_year()) std::cout << " (" << this->get_year() << ")";
   std::cout << "\n";
}
